//
//	64bit types
//

#ifndef	_TYPES_H_
#define	_TYPES_H_


#ifndef NULL
#ifdef __cplusplus
#define	NULL	0
#else
#define	NULL	((void*)0)
#endif
#endif


//	Native types
#ifndef _MSC_VER
#define	__int64 long long
#endif
typedef	unsigned char		byte,uint8;
typedef	signed char			sbyte,int8;
typedef	unsigned short		word,uint16;
typedef	signed short		int16;
typedef	unsigned int		dword,uint,uint32;
typedef	signed int			int32;
typedef	unsigned __int64	qword,uint64;
typedef	signed __int64		int64;
typedef	void				*pvoid;
typedef	int32				HFILE;
typedef	int8				DOSRESULT;
typedef	const char			*string;
#define	interface			struct

#ifdef _PEKOE32_
typedef	signed int			sintptr;
typedef	unsigned int		intptr;
#if 0//def _MSC_VER
typedef	unsigned long		size_t;
typedef	signed long			ssize_t;
#else
typedef	unsigned int		size_t;
typedef	signed int			ssize_t;
#endif
#else
typedef	signed __int64		sintptr;
typedef	unsigned __int64	intptr;
typedef	unsigned long		size_t;
typedef	signed long			ssize_t;
#endif


typedef	unsigned long		time_t;


//	WIN64 types
#undef FAR
#undef NEAR
#define FAR
#define NEAR
#ifndef CONST
#define CONST		const
#endif

#ifndef FALSE
#define FALSE				0
#endif

#ifndef TRUE
#define TRUE				1
#endif

#ifndef IN
#define IN
#endif

#ifndef OUT
#define OUT
#endif

#ifndef OPTIONAL
#define OPTIONAL
#endif

typedef	uint32				UINT32,ULONG32;
typedef	int32				INT32,LONG32;
typedef	uint64				UINT64,ULONG64;
typedef	size_t				SIZE_T;
typedef	intptr				UINT_PTR,ULONG_PTR;
typedef	int64				INT64,LONG64;
typedef	ssize_t				SSIZE_T;
typedef	sintptr				INT_PTR,LONG_PTR;

typedef	uint64				ULONGLONG;
typedef	uint32				ULONG,*PULONG;
typedef	unsigned int		UINT,*PUINT;
typedef	unsigned short		USHORT,*PUSHORT;
typedef	unsigned char		UCHAR,*PUCHAR;
typedef	int64				LONGLONG;
typedef	int32				LONG,*PLONG,*LPLONG;
typedef	int					INT,*PINT;
typedef	short				SHORT,*PSHORT;
typedef	signed char			CHAR,*PCHAR;
typedef	char				*PSZ;

typedef	int					BOOL,*PBOOL,*LPBOOL;
typedef	uint8				BYTE,*PBYTE,*LPBYTE;
typedef	uint16				WORD,*PWORD,*LPWORD;
typedef	uint32				DWORD,*PDWORD,*LPDWORD;
typedef	uint64				QWORD,*PQWORD,*LPQWORD;
typedef	uint32				DWORD32,*PDWORD32;
typedef	uint64				DWORD64,*PDWORD64;
typedef	float				FLOAT,*PFLOAT;
typedef	void FAR			*LPVOID;
typedef	CONST void FAR		*LPCVOID;

typedef	void				VOID,*LPVOID,*PVOID,*HANDLE;
typedef	char				*LPSTR;
typedef	const char			*LPCSTR;
typedef	char				TCHAR;
typedef	TCHAR				*LPTSTR;
typedef	const TCHAR			*LPCTSTR;
interface	IUnknown;

#define LODWORD(q)	((dword)(q))
#define HIDWORD(q)	((dword)(((qword)(q) >> 32) & 0xFFFFFFFF))
#define LOWORD(l)	((WORD)(l))
#define HIWORD(l)	((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define LOBYTE(w)	((BYTE)(w))
#define HIBYTE(w)	((BYTE)(((WORD)(w) >> 8) & 0xFF))

#endif
